/* TeeJee.FileSystem.c generated by valac 0.39.7, the Vala compiler
 * generated from TeeJee.FileSystem.vala, do not modify */

/*
 * TeeJee.FileSystem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <stdio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))



#define TEE_JEE_FILE_SYSTEM_KB ((gint64) 1000)
#define TEE_JEE_FILE_SYSTEM_MB (1000 * TEE_JEE_FILE_SYSTEM_KB)
#define TEE_JEE_FILE_SYSTEM_GB (1000 * TEE_JEE_FILE_SYSTEM_MB)
#define TEE_JEE_FILE_SYSTEM_TB (1000 * TEE_JEE_FILE_SYSTEM_GB)
#define TEE_JEE_FILE_SYSTEM_KiB ((gint64) 1024)
#define TEE_JEE_FILE_SYSTEM_MiB (1024 * TEE_JEE_FILE_SYSTEM_KiB)
#define TEE_JEE_FILE_SYSTEM_GiB (1024 * TEE_JEE_FILE_SYSTEM_MiB)
#define TEE_JEE_FILE_SYSTEM_TiB (1024 * TEE_JEE_FILE_SYSTEM_GiB)
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gchar* tee_jee_file_system_file_basename (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
gboolean tee_jee_file_system_file_or_dir_exists (const gchar* item_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gboolean tee_jee_file_system_file_exists_regular (const gchar* file_path);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gboolean tee_jee_file_system_file_move_to_trash (const gchar* file_path);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gboolean tee_jee_file_system_file_shred (const gchar* file_path);
gint64 tee_jee_file_system_file_line_count (const gchar* file_path);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean tee_jee_file_system_file_copy (const gchar* src_file,
                                        const gchar* dest_file);
void tee_jee_file_system_file_move (const gchar* src_file,
                                    const gchar* dest_file);
gboolean tee_jee_file_system_file_gzip (const gchar* src_file);
gboolean tee_jee_file_system_file_gunzip (const gchar* src_file);
gchar* tee_jee_file_system_file_resolve_executable_path (const gchar* file_path);
gint64 tee_jee_file_system_file_get_size (const gchar* file_path);
GDateTime* tee_jee_file_system_file_get_modified_date (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean tee_jee_file_system_dir_delete (const gchar* dir_path,
                                         gboolean show_message);
void tee_jee_logging_log_debug (const gchar* message);
gboolean tee_jee_file_system_dir_move_to_trash (const gchar* dir_path);
gboolean tee_jee_file_system_dir_is_empty (const gchar* dir_path);
gboolean tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                            gboolean* is_readonly);
gchar* tee_jee_misc_random_string (gint length,
                                   const gchar* charset);
GeeArrayList* tee_jee_file_system_dir_list_names (const gchar* path);
static gint __lambda17_ (const gchar* a,
                  const gchar* b);
static gint ___lambda17__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
gboolean tee_jee_file_system_dir_tar (const gchar* src_dir,
                                      const gchar* tar_file,
                                      gboolean recursion);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gboolean tee_jee_file_system_dir_untar (const gchar* tar_file,
                                        const gchar* dst_dir);
gboolean tee_jee_file_system_chown (const gchar* dir_path,
                                    const gchar* user,
                                    const gchar* group);
glong tee_jee_file_system_dir_count (const gchar* path);
glong tee_jee_file_system_dir_size (const gchar* path);
glong tee_jee_file_system_dir_size_kb (const gchar* path);
gboolean tee_jee_file_system_file_tar_encrypt (const gchar* src_file,
                                               const gchar* dst_file,
                                               const gchar* password);
gchar* tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                                    const gchar* password);
gboolean tee_jee_file_system_decrypt_and_untar (const gchar* src_file,
                                                const gchar* dst_file,
                                                const gchar* password);
gchar* tee_jee_file_system_hash_md5 (const gchar* path);
gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
gint tee_jee_file_system_chmod (const gchar* file,
                                const gchar* permission);
gchar* tee_jee_file_system_resolve_relative_path (const gchar* filePath);
gint tee_jee_file_system_rsync (const gchar* sourceDirectory,
                                const gchar* destDirectory,
                                gboolean updateExisting,
                                gboolean deleteExtra);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


gchar*
tee_jee_file_system_file_parent (const gchar* file_path)
{
	gchar* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 45 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_parent (_tmp1_);
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp3_);
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp5_;
#line 46 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 188 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_basename (const gchar* file_path)
{
	gchar* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 49 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 50 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 50 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 50 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_basename (_tmp1_);
#line 50 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 50 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp3_;
#line 50 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 216 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_path_combine (const gchar* path1,
                                  const gchar* path2)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 53 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path1 != NULL, NULL);
#line 53 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path2 != NULL, NULL);
#line 54 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_build_path ("/", path1, path2, NULL);
#line 54 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 54 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 236 "TeeJee.FileSystem.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1369 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1371 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 262 "TeeJee.FileSystem.c"
		glong _tmp2_;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		start = _tmp2_ + start;
#line 268 "TeeJee.FileSystem.c"
	}
#line 1374 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 272 "TeeJee.FileSystem.c"
		glong _tmp3_;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		end = _tmp3_ + end;
#line 278 "TeeJee.FileSystem.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 282 "TeeJee.FileSystem.c"
		glong _tmp5_;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 288 "TeeJee.FileSystem.c"
	} else {
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 292 "TeeJee.FileSystem.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 298 "TeeJee.FileSystem.c"
		glong _tmp7_;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 304 "TeeJee.FileSystem.c"
	} else {
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 308 "TeeJee.FileSystem.c"
	}
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1379 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp8_;
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 320 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_remove_trailing_slash (const gchar* path)
{
	gchar* result = NULL;
#line 57 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 58 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_str_has_suffix (path, "/")) {
#line 332 "TeeJee.FileSystem.c"
		gint _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
#line 59 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = strlen (path);
#line 59 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 59 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = string_slice (path, (glong) 0, (glong) (_tmp1_ - 1));
#line 59 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = _tmp2_;
#line 59 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 346 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp3_;
#line 62 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup (path);
#line 62 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = _tmp3_;
#line 62 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 355 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_file_or_dir_exists (const gchar* item_path)
{
	gboolean result = FALSE;
	GFile* item = NULL;
	GFile* _tmp0_;
#line 68 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (item_path != NULL, FALSE);
#line 72 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_parse_name (item_path);
#line 72 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	item = _tmp0_;
#line 73 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = g_file_query_exists (item, NULL);
#line 73 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (item);
#line 73 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 378 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_exists (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 76 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 78 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 79 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = !g_file_test (file_path, G_FILE_TEST_IS_DIR);
#line 393 "TeeJee.FileSystem.c"
	} else {
#line 78 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 397 "TeeJee.FileSystem.c"
	}
#line 78 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 78 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 403 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_exists_regular (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 82 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 84 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 85 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (file_path, G_FILE_TEST_IS_REGULAR);
#line 418 "TeeJee.FileSystem.c"
	} else {
#line 84 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 422 "TeeJee.FileSystem.c"
	}
#line 84 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 84 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 428 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_delete (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 88 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 440 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 93 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 93 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 94 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 94 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 453 "TeeJee.FileSystem.c"
			GFile* _tmp2_;
#line 95 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 95 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp2_, NULL, &_inner_error_);
#line 95 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 463 "TeeJee.FileSystem.c"
				goto __catch64_g_error;
			}
		}
#line 97 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 97 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 97 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 473 "TeeJee.FileSystem.c"
	}
	goto __finally64;
	__catch64_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 92 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 92 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 99 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = e;
#line 99 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_->message;
#line 99 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 100 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_strdup_printf (": %s", file_path);
#line 100 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 100 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strconcat (_ ("Failed to delete file"), _tmp6_, NULL);
#line 100 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 100 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 100 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 100 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp6_);
#line 101 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 101 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 101 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 515 "TeeJee.FileSystem.c"
	}
	__finally64:
#line 92 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 92 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 92 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return _tmp9_;
#line 524 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_move_to_trash (const gchar* file_path)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 105 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 109 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 109 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	file = _tmp0_;
#line 110 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = file;
#line 110 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_query_exists (_tmp1_, NULL)) {
#line 545 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 111 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (file_path);
#line 111 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 111 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("gvfs-trash '%s'", _tmp3_);
#line 111 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 111 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		system (_tmp5_);
#line 111 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 111 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 564 "TeeJee.FileSystem.c"
	}
#line 113 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = TRUE;
#line 113 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (file);
#line 113 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 572 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_shred (const gchar* file_path)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 116 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 120 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 120 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	file = _tmp0_;
#line 121 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = file;
#line 121 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_query_exists (_tmp1_, NULL)) {
#line 593 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 122 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (file_path);
#line 122 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 122 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("shred -u '%s'", _tmp3_);
#line 122 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 122 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		system (_tmp5_);
#line 122 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 122 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 612 "TeeJee.FileSystem.c"
	}
#line 124 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = TRUE;
#line 124 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (file);
#line 124 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 620 "TeeJee.FileSystem.c"
}


gint64
tee_jee_file_system_file_line_count (const gchar* file_path)
{
	gint64 result = 0LL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gint64 _tmp10_;
#line 127 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 129 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file_path);
#line 129 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 129 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("wc -l '%s'", _tmp1_);
#line 129 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 129 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 129 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 131 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 131 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 131 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 131 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 131 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = (gint64) atol (_tmp9_);
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 132 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 689 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_read (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* txt = NULL;
	gsize size = 0UL;
	GError * _inner_error_ = NULL;
#line 135 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 702 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_ = NULL;
		gsize _tmp1_ = 0UL;
#line 143 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_file_get_contents (file_path, &_tmp0_, &_tmp1_, &_inner_error_);
#line 143 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 143 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		txt = _tmp0_;
#line 143 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		size = _tmp1_;
#line 143 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 716 "TeeJee.FileSystem.c"
			goto __catch65_g_error;
		}
#line 144 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = txt;
#line 144 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 723 "TeeJee.FileSystem.c"
	}
	goto __finally65;
	__catch65_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 147 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = e;
#line 147 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_->message;
#line 147 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp3_, FALSE, FALSE);
#line 148 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf (": %s", file_path);
#line 148 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 148 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_ ("Failed to read file"), _tmp5_, NULL);
#line 148 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 148 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 148 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 148 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 761 "TeeJee.FileSystem.c"
	}
	__finally65:
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 142 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 774 "TeeJee.FileSystem.c"
	}
#line 151 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = NULL;
#line 151 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (txt);
#line 151 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 782 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_write (const gchar* file_path,
                                const gchar* contents)
{
	gboolean result = FALSE;
	gboolean _tmp17_ = FALSE;
	GError * _inner_error_ = NULL;
#line 154 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 154 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 797 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* file = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp5_;
		GFileOutputStream* _tmp6_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp7_;
		GDataOutputStream* _tmp8_;
		GDataOutputStream* _tmp9_;
		GDataOutputStream* _tmp10_;
#line 160 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (file_path);
#line 160 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 160 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_dir_create (_tmp1_, FALSE);
#line 160 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 162 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_file_new_for_path (file_path);
#line 162 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp2_;
#line 163 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = file;
#line 163 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 828 "TeeJee.FileSystem.c"
			GFile* _tmp4_;
#line 164 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file;
#line 164 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp4_, NULL, &_inner_error_);
#line 164 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 164 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 838 "TeeJee.FileSystem.c"
				goto __catch66_g_error;
			}
		}
#line 167 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = file;
#line 167 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_file_create (_tmp5_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 167 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file_stream = _tmp6_;
#line 167 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 167 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 852 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 168 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = file_stream;
#line 168 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_data_output_stream_new ((GOutputStream*) _tmp7_);
#line 168 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		data_stream = _tmp8_;
#line 169 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = data_stream;
#line 169 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_data_output_stream_put_string (_tmp9_, contents, NULL, &_inner_error_);
#line 169 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 169 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 169 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 169 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 873 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 170 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = data_stream;
#line 170 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_output_stream_close ((GOutputStream*) _tmp10_, NULL, &_inner_error_);
#line 170 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 170 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 170 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 170 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 888 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 171 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 171 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (data_stream);
#line 171 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_stream);
#line 171 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 171 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 901 "TeeJee.FileSystem.c"
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 158 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 158 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 174 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 174 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 174 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 175 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", file_path);
#line 175 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 175 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to write file"), _tmp14_, NULL);
#line 175 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 175 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 175 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 175 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 176 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 176 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 176 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 943 "TeeJee.FileSystem.c"
	}
	__finally66:
#line 158 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 952 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_copy (const gchar* src_file,
                               const gchar* dest_file)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 180 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 180 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dest_file != NULL, FALSE);
#line 966 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 182 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 182 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 183 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 183 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 979 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 184 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 184 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 185 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 185 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 185 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			g_file_copy (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 185 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 185 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 185 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 1000 "TeeJee.FileSystem.c"
				goto __catch67_g_error;
			}
#line 186 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 186 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 186 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_src);
#line 186 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1011 "TeeJee.FileSystem.c"
		}
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 1015 "TeeJee.FileSystem.c"
	}
	goto __finally67;
	__catch67_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 190 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 190 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 190 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 191 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 191 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 191 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_ ("Failed to copy file"), _tmp8_, NULL);
#line 191 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 191 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 191 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 191 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1053 "TeeJee.FileSystem.c"
	}
	__finally67:
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1058 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 181 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 1066 "TeeJee.FileSystem.c"
	}
#line 194 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 194 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1072 "TeeJee.FileSystem.c"
}


void
tee_jee_file_system_file_move (const gchar* src_file,
                               const gchar* dest_file)
{
	GError * _inner_error_ = NULL;
#line 197 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (src_file != NULL);
#line 197 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (dest_file != NULL);
#line 1085 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 199 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 199 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 200 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 200 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1098 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 201 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 201 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 202 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 202 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 202 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			g_file_move (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 202 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 202 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 202 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 1119 "TeeJee.FileSystem.c"
				goto __catch68_g_error;
			}
#line 200 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 1124 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 205 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_strdup_printf (": '%s'", src_file);
#line 205 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 205 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = g_strconcat (_ ("File not found"), _tmp6_, NULL);
#line 205 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp7_;
#line 205 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 205 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp8_);
#line 205 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp6_);
#line 1144 "TeeJee.FileSystem.c"
		}
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 1148 "TeeJee.FileSystem.c"
	}
	goto __finally68;
	__catch68_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 209 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 209 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 209 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 210 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 210 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 210 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strconcat (_ ("Failed to move file"), _tmp12_, NULL);
#line 210 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 210 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 210 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 210 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1186 "TeeJee.FileSystem.c"
	}
	__finally68:
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 198 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return;
#line 1197 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_file_gzip (const gchar* src_file)
{
	gboolean result = FALSE;
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 214 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 216 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strconcat (src_file, ".gz", NULL);
#line 216 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 217 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 219 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 219 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 219 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gzip '%s'", _tmp2_);
#line 219 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 219 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 219 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 221 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 221 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 221 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 221 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 221 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 223 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 223 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 223 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 223 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 223 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 223 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1259 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_gunzip (const gchar* src_file)
{
	gboolean result = FALSE;
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 226 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 228 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup (src_file);
#line 228 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 229 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 231 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 231 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 231 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gunzip '%s'", _tmp2_);
#line 231 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 231 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 231 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 233 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 233 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 233 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 233 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 233 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 235 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 235 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 235 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 235 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 235 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 235 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1320 "TeeJee.FileSystem.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 1340 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_resolve_executable_path (const gchar* file_path)
{
	gchar* result = NULL;
#line 238 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 240 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (file_path, "/")) {
#line 1352 "TeeJee.FileSystem.c"
		gchar* _tmp0_;
#line 241 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup (file_path);
#line 241 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = _tmp0_;
#line 241 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 1360 "TeeJee.FileSystem.c"
	} else {
#line 243 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (!string_contains (file_path, "/")) {
#line 1364 "TeeJee.FileSystem.c"
			gchar* _tmp1_;
#line 244 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp1_ = g_find_program_in_path (file_path);
#line 244 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp1_;
#line 244 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1372 "TeeJee.FileSystem.c"
		} else {
#line 246 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (g_str_has_prefix (file_path, "./")) {
#line 1376 "TeeJee.FileSystem.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp2_ = g_get_current_dir ();
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp3_ = _tmp2_;
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp4_ = strlen (file_path);
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp5_ = _tmp4_;
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp6_ = string_slice (file_path, (glong) 2, (glong) _tmp5_);
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp6_;
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp8_ = tee_jee_file_system_path_combine (_tmp3_, _tmp7_);
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp9_ = _tmp8_;
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp7_);
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp3_);
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				result = _tmp9_;
#line 247 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				return result;
#line 1409 "TeeJee.FileSystem.c"
			} else {
#line 249 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (g_str_has_prefix (file_path, "../")) {
#line 1413 "TeeJee.FileSystem.c"
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp10_ = g_get_current_dir ();
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp11_ = _tmp10_;
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp12_ = tee_jee_file_system_file_parent (_tmp11_);
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp13_ = _tmp12_;
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp14_ = strlen (file_path);
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp15_ = _tmp14_;
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp16_ = string_slice (file_path, (glong) 3, (glong) _tmp15_);
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp17_ = _tmp16_;
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp18_ = tee_jee_file_system_path_combine (_tmp13_, _tmp17_);
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp19_ = _tmp18_;
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp17_);
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp13_);
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp11_);
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					result = _tmp19_;
#line 250 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					return result;
#line 1454 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 253 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp20_ = g_get_current_dir ();
#line 253 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp21_ = _tmp20_;
#line 253 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp22_ = tee_jee_file_system_path_combine (_tmp21_, file_path);
#line 253 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp23_ = _tmp22_;
#line 253 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp21_);
#line 253 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					result = _tmp23_;
#line 253 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					return result;
#line 1474 "TeeJee.FileSystem.c"
				}
			}
		}
	}
}


gint64
tee_jee_file_system_file_get_size (const gchar* file_path)
{
	gint64 result = 0LL;
	GError * _inner_error_ = NULL;
#line 259 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 1489 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 261 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 261 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 262 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 1499 "TeeJee.FileSystem.c"
			gboolean _tmp1_ = FALSE;
#line 263 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (g_file_test (file_path, G_FILE_TEST_IS_REGULAR)) {
#line 264 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp1_ = !g_file_test (file_path, G_FILE_TEST_IS_SYMLINK);
#line 1505 "TeeJee.FileSystem.c"
			} else {
#line 263 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp1_ = FALSE;
#line 1509 "TeeJee.FileSystem.c"
			}
#line 263 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp1_) {
#line 1513 "TeeJee.FileSystem.c"
				GFileInfo* _tmp2_ = NULL;
				GFile* _tmp3_;
				GFileInfo* _tmp4_;
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp3_ = file;
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp4_ = g_file_query_info (_tmp3_, "standard::size", 0, NULL, &_inner_error_);
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp2_ = _tmp4_;
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (file);
#line 1527 "TeeJee.FileSystem.c"
					goto __catch69_g_error;
				}
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				result = g_file_info_get_size (_tmp2_);
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp2_);
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 265 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				return result;
#line 1538 "TeeJee.FileSystem.c"
			}
		}
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1543 "TeeJee.FileSystem.c"
	}
	goto __finally69;
	__catch69_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 270 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 270 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 270 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1563 "TeeJee.FileSystem.c"
	}
	__finally69:
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1568 "TeeJee.FileSystem.c"
		gint64 _tmp7_ = 0LL;
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 260 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return _tmp7_;
#line 1576 "TeeJee.FileSystem.c"
	}
#line 273 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = (gint64) -1;
#line 273 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1582 "TeeJee.FileSystem.c"
}


GDateTime*
tee_jee_file_system_file_get_modified_date (const gchar* file_path)
{
	GDateTime* result = NULL;
	GDateTime* _tmp17_;
	GError * _inner_error_ = NULL;
#line 276 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1594 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 279 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 279 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 280 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 280 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1608 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GTimeVal _tmp10_ = {0};
			GDateTime* _tmp11_;
			GDateTime* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error_);
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1642 "TeeJee.FileSystem.c"
				goto __catch70_g_error;
			}
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 281 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			g_file_info_get_modification_time (_tmp9_, &_tmp10_);
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_date_time_new_from_timeval_utc (&_tmp10_);
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = _tmp11_;
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_date_time_to_local (_tmp12_);
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp14_ = _tmp13_;
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_date_time_unref0 (_tmp12_);
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp14_;
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 282 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1677 "TeeJee.FileSystem.c"
		}
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1683 "TeeJee.FileSystem.c"
	}
	goto __finally70;
	__catch70_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 286 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = e;
#line 286 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_->message;
#line 286 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1703 "TeeJee.FileSystem.c"
	}
	__finally70:
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 277 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1714 "TeeJee.FileSystem.c"
	}
#line 289 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp17_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 289 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp17_;
#line 289 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1722 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_get_symlink_target (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* _tmp14_;
	GError * _inner_error_ = NULL;
#line 292 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1734 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 295 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 295 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 296 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 296 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1748 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error_);
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1779 "TeeJee.FileSystem.c"
				goto __catch71_g_error;
			}
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 297 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp10_ = g_file_info_get_symlink_target (_tmp9_);
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp11_;
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 298 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1806 "TeeJee.FileSystem.c"
		}
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1812 "TeeJee.FileSystem.c"
	}
	goto __finally71;
	__catch71_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 302 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 302 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 302 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1832 "TeeJee.FileSystem.c"
	}
	__finally71:
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 293 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1843 "TeeJee.FileSystem.c"
	}
#line 305 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strdup ("");
#line 305 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp14_;
#line 305 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1851 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_exists (const gchar* dir_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 310 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 312 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_test (dir_path, G_FILE_TEST_EXISTS)) {
#line 312 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (dir_path, G_FILE_TEST_IS_DIR);
#line 1866 "TeeJee.FileSystem.c"
	} else {
#line 312 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 1870 "TeeJee.FileSystem.c"
	}
#line 312 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 312 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1876 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_create (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean result = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 315 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 1889 "TeeJee.FileSystem.c"
	{
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 320 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 320 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 321 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 321 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL) == FALSE) {
#line 1902 "TeeJee.FileSystem.c"
			gboolean ok = FALSE;
			GFile* _tmp2_;
#line 322 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 322 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			ok = g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error_);
#line 322 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 322 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 1913 "TeeJee.FileSystem.c"
				goto __catch72_g_error;
			}
#line 323 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (show_message) {
#line 1918 "TeeJee.FileSystem.c"
				gboolean _tmp3_;
#line 324 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp3_ = ok;
#line 324 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (_tmp3_) {
#line 1924 "TeeJee.FileSystem.c"
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
#line 325 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp4_ = g_strdup_printf (": %s", dir_path);
#line 325 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp5_ = _tmp4_;
#line 325 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp6_ = g_strconcat (_ ("Created directory"), _tmp5_, NULL);
#line 325 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp7_ = _tmp6_;
#line 325 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 325 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp7_);
#line 325 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp5_);
#line 1943 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
#line 328 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp8_ = g_strdup_printf (": %s", dir_path);
#line 328 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp9_ = _tmp8_;
#line 328 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp10_ = g_strconcat (_ ("Failed to create directory"), _tmp9_, NULL);
#line 328 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp11_ = _tmp10_;
#line 328 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_error (_tmp11_, FALSE, FALSE);
#line 328 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp11_);
#line 328 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp9_);
#line 1963 "TeeJee.FileSystem.c"
				}
			}
		}
#line 332 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 332 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 332 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 1973 "TeeJee.FileSystem.c"
	}
	goto __finally72;
	__catch72_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 319 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 319 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 335 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 335 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 335 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 336 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = g_strdup_printf (": %s", dir_path);
#line 336 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 336 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = g_strconcat (_ ("Failed to create directory"), _tmp15_, NULL);
#line 336 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = _tmp16_;
#line 336 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 336 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp17_);
#line 336 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 337 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 337 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 337 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2015 "TeeJee.FileSystem.c"
	}
	__finally72:
#line 319 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 319 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 319 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return _tmp18_;
#line 2024 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_delete (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
	gint _tmp20_;
#line 341 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 345 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (!tee_jee_file_system_dir_exists (dir_path)) {
#line 346 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 346 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2055 "TeeJee.FileSystem.c"
	}
#line 349 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 349 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 349 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("rm -rf '%s'", _tmp1_);
#line 349 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 349 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 349 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 350 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 350 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_logging_log_debug (_tmp4_);
#line 352 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 352 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_process_helper_exec_sync (_tmp5_, &_tmp6_, &_tmp7_);
#line 352 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 352 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp6_;
#line 352 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 352 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp7_;
#line 352 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	status = _tmp8_;
#line 353 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (show_message) {
#line 2089 "TeeJee.FileSystem.c"
		gint _tmp9_;
#line 354 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = status;
#line 354 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp9_ == 0) {
#line 2095 "TeeJee.FileSystem.c"
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 355 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp10_ = g_strdup_printf (": %s", dir_path);
#line 355 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = _tmp10_;
#line 355 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = g_strconcat (_ ("Deleted directory"), _tmp11_, NULL);
#line 355 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = _tmp12_;
#line 355 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp13_, FALSE);
#line 355 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp13_);
#line 355 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp11_);
#line 2114 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
#line 358 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp14_ = g_strdup_printf (": %s", dir_path);
#line 358 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp15_ = _tmp14_;
#line 358 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp16_ = g_strconcat (_ ("Failed to delete directory"), _tmp15_, NULL);
#line 358 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp17_ = _tmp16_;
#line 358 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 358 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp17_);
#line 358 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp15_);
#line 359 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp18_ = std_out;
#line 359 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 360 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp19_ = std_err;
#line 360 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp19_, FALSE, FALSE);
#line 2144 "TeeJee.FileSystem.c"
		}
	}
#line 364 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp20_ = status;
#line 364 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp20_ == 0;
#line 364 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 364 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 364 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 364 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2159 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_move_to_trash (const gchar* dir_path)
{
	gboolean result = FALSE;
#line 367 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 368 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_move_to_trash (dir_path);
#line 368 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2173 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_is_empty (const gchar* dir_path)
{
	gboolean result = FALSE;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
#line 371 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 2185 "TeeJee.FileSystem.c"
	{
		gboolean is_empty = FALSE;
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 376 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		is_empty = TRUE;
#line 377 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 377 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 378 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 378 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 2201 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFileEnumerator* enu = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileEnumerator* _tmp5_;
			GFileEnumerator* _tmp6_;
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error_);
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			enu = _tmp6_;
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 380 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 2229 "TeeJee.FileSystem.c"
				goto __catch73_g_error;
			}
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			while (TRUE) {
#line 2234 "TeeJee.FileSystem.c"
				GFileInfo* _tmp7_ = NULL;
				GFileEnumerator* _tmp8_;
				GFileInfo* _tmp9_;
				GFileInfo* _tmp10_;
				GFileInfo* _tmp11_;
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp8_ = enu;
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error_);
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp9_;
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (enu);
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (info);
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (dir);
#line 2254 "TeeJee.FileSystem.c"
					goto __catch73_g_error;
				}
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp10_ = _tmp7_;
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp7_ = NULL;
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				info = _tmp10_;
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp11_ = info;
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (!(_tmp11_ != NULL)) {
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (_tmp7_);
#line 381 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					break;
#line 2273 "TeeJee.FileSystem.c"
				}
#line 382 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				is_empty = FALSE;
#line 383 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 383 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				break;
#line 2281 "TeeJee.FileSystem.c"
			}
#line 378 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (enu);
#line 378 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 2287 "TeeJee.FileSystem.c"
		}
#line 386 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = is_empty;
#line 386 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 386 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2295 "TeeJee.FileSystem.c"
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 375 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 375 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 389 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 389 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 389 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 390 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 390 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 390 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2319 "TeeJee.FileSystem.c"
	}
	__finally73:
#line 375 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 375 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 375 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return _tmp14_;
#line 2328 "TeeJee.FileSystem.c"
}


static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar* * unparsed)
{
	gint64 _vala_result = 0LL;
	const gchar* _vala_unparsed = NULL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 694 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, (guint) 0);
#line 694 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	endptr = _tmp0_;
#line 694 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_vala_result = _tmp1_;
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = endptr;
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 696 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_vala_unparsed = "";
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (_result_) {
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2370 "TeeJee.FileSystem.c"
		}
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (unparsed) {
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2376 "TeeJee.FileSystem.c"
		}
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 2380 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp5_;
#line 699 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = endptr;
#line 699 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (_result_) {
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2393 "TeeJee.FileSystem.c"
		}
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (unparsed) {
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2399 "TeeJee.FileSystem.c"
		}
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 2403 "TeeJee.FileSystem.c"
	}
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_result_) {
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*_result_ = _vala_result;
#line 2409 "TeeJee.FileSystem.c"
	}
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (unparsed) {
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*unparsed = _vala_unparsed;
#line 2415 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                   gboolean* is_readonly)
{
	gboolean _vala_is_readonly = FALSE;
	gboolean result = FALSE;
	gboolean supports_hardlinks = FALSE;
	gchar* test_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
#line 394 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 395 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	supports_hardlinks = FALSE;
#line 396 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_vala_is_readonly = FALSE;
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strconcat (_tmp1_, "~", NULL);
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_file_system_path_combine (path, _tmp3_);
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp3_);
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 398 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	test_file = _tmp5_;
#line 400 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp6_ = test_file;
#line 400 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_write (_tmp6_, "")) {
#line 2463 "TeeJee.FileSystem.c"
		gchar* test_file2 = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* cmd = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gint status = 0;
		const gchar* _tmp22_;
		gint _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* std_out = NULL;
		gchar* std_err = NULL;
		const gchar* _tmp29_;
		gchar* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
		gint _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gint64 count = 0LL;
		const gchar* _tmp36_;
		gint64 _tmp37_ = 0LL;
		gboolean _tmp38_;
		const gchar* _tmp40_;
		const gchar* _tmp41_;
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_tmp8_, "~", NULL);
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_path_combine (path, _tmp10_);
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 402 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		test_file2 = _tmp12_;
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = test_file;
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = test_file2;
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_file_system_escape_single_quote (_tmp16_);
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf ("ln '%s' '%s'", _tmp15_, _tmp18_);
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 404 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp20_;
#line 408 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = cmd;
#line 408 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp21_);
#line 410 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = cmd;
#line 410 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = tee_jee_process_helper_exec_sync (_tmp22_, NULL, NULL);
#line 410 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp23_;
#line 412 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = test_file;
#line 412 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp25_ = tee_jee_file_system_escape_single_quote (_tmp24_);
#line 412 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp26_ = _tmp25_;
#line 412 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp27_ = g_strdup_printf ("stat --printf '%%h' '%s'", _tmp26_);
#line 412 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 412 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp27_;
#line 412 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp26_);
#line 415 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp28_ = cmd;
#line 415 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp28_);
#line 418 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = cmd;
#line 418 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp32_ = tee_jee_process_helper_exec_sync (_tmp29_, &_tmp30_, &_tmp31_);
#line 418 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 418 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		std_out = _tmp30_;
#line 418 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 418 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		std_err = _tmp31_;
#line 418 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp32_;
#line 419 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp33_ = std_out;
#line 419 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp34_ = g_strdup_printf ("stdout: %s", _tmp33_);
#line 419 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp35_ = _tmp34_;
#line 419 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp35_);
#line 419 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp35_);
#line 421 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		count = (gint64) 0;
#line 422 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp36_ = std_out;
#line 422 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp38_ = int64_try_parse (_tmp36_, &_tmp37_, NULL);
#line 422 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		count = _tmp37_;
#line 422 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp38_) {
#line 2606 "TeeJee.FileSystem.c"
			gint64 _tmp39_;
#line 423 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp39_ = count;
#line 423 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp39_ > ((gint64) 1)) {
#line 424 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				supports_hardlinks = TRUE;
#line 2614 "TeeJee.FileSystem.c"
			}
		}
#line 428 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp40_ = test_file2;
#line 428 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp40_);
#line 429 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp41_ = test_file;
#line 429 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp41_);
#line 400 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 400 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 400 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 400 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (test_file2);
#line 2633 "TeeJee.FileSystem.c"
	} else {
#line 432 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_vala_is_readonly = TRUE;
#line 2637 "TeeJee.FileSystem.c"
	}
#line 435 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = supports_hardlinks;
#line 435 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (test_file);
#line 435 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (is_readonly) {
#line 435 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		*is_readonly = _vala_is_readonly;
#line 2647 "TeeJee.FileSystem.c"
	}
#line 435 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2651 "TeeJee.FileSystem.c"
}


static gint
__lambda17_ (const gchar* a,
             const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
#line 456 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 456 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 457 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strcmp0;
#line 457 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_ (a, b);
#line 457 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2671 "TeeJee.FileSystem.c"
}


static gint
___lambda17__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda17_ ((const gchar*) a, (const gchar*) b);
#line 456 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2684 "TeeJee.FileSystem.c"
}


GeeArrayList*
tee_jee_file_system_dir_list_names (const gchar* path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GCompareDataFunc entry_compare = NULL;
	void* entry_compare_target;
	GDestroyNotify entry_compare_target_destroy_notify;
	GeeArrayList* _tmp19_;
	GCompareDataFunc _tmp20_;
	void* _tmp20__target;
	GDestroyNotify _tmp20__target_destroy_notify;
	GError * _inner_error_ = NULL;
#line 438 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 439 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 439 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	list = _tmp0_;
#line 2708 "TeeJee.FileSystem.c"
	{
		GFile* f_home = NULL;
		GFile* _tmp1_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileEnumerator* _tmp6_;
		GFileInfo* file = NULL;
#line 443 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 443 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		f_home = _tmp1_;
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = f_home;
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error_);
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		enumerator = _tmp6_;
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 444 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (f_home);
#line 2741 "TeeJee.FileSystem.c"
			goto __catch74_g_error;
		}
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		while (TRUE) {
#line 2746 "TeeJee.FileSystem.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* name = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GeeArrayList* _tmp15_;
			const gchar* _tmp16_;
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = enumerator;
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error_);
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp9_;
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (enumerator);
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (f_home);
#line 2772 "TeeJee.FileSystem.c"
				goto __catch74_g_error;
			}
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp7_;
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = NULL;
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			file = _tmp10_;
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = file;
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (!(_tmp11_ != NULL)) {
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				break;
#line 2791 "TeeJee.FileSystem.c"
			}
#line 447 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = file;
#line 447 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 447 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 447 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			name = _tmp14_;
#line 448 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp15_ = list;
#line 448 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp16_ = name;
#line 448 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (name);
#line 446 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp7_);
#line 2811 "TeeJee.FileSystem.c"
		}
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (enumerator);
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (f_home);
#line 2819 "TeeJee.FileSystem.c"
	}
	goto __finally74;
	__catch74_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 452 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = e;
#line 452 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_->message;
#line 452 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 2839 "TeeJee.FileSystem.c"
	}
	__finally74:
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (list);
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 441 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 2852 "TeeJee.FileSystem.c"
	}
#line 456 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare = ___lambda17__gcompare_data_func;
#line 456 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 456 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp19_ = list;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp20_ = entry_compare;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp20__target = entry_compare_target;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp20__target_destroy_notify = entry_compare_target_destroy_notify;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 459 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	gee_list_sort ((GeeList*) _tmp19_, _tmp20_, _tmp20__target, _tmp20__target_destroy_notify);
#line 461 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = list;
#line 461 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	(entry_compare_target_destroy_notify == NULL) ? NULL : (entry_compare_target_destroy_notify (entry_compare_target), NULL);
#line 461 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 461 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 461 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 461 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2888 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_tar (const gchar* src_dir,
                             const gchar* tar_file,
                             gboolean recursion)
{
	gboolean result = FALSE;
#line 464 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_dir != NULL, FALSE);
#line 464 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (tar_file != NULL, FALSE);
#line 465 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_dir_exists (src_dir)) {
#line 2904 "TeeJee.FileSystem.c"
		gchar* src_parent = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_ = NULL;
		gchar* cmd = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp14_;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gint _tmp17_;
		gint _tmp18_;
#line 467 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (tar_file)) {
#line 468 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (tar_file);
#line 2934 "TeeJee.FileSystem.c"
		}
#line 471 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_dir);
#line 471 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		src_parent = _tmp0_;
#line 472 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_dir);
#line 472 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 476 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (recursion) {
#line 476 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = "";
#line 2948 "TeeJee.FileSystem.c"
		} else {
#line 476 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = "no-";
#line 2952 "TeeJee.FileSystem.c"
		}
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = tee_jee_file_system_escape_single_quote (tar_file);
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = src_parent;
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = tee_jee_file_system_escape_single_quote (_tmp5_);
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = src_name;
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = tee_jee_file_system_escape_single_quote (_tmp8_);
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf ("tar cvf '%s' --overwrite --%srecursion -C '%s' '%s'\n", _tmp4_, _tmp2_, _tmp7_, _tmp10_);
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 474 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp12_;
#line 480 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = cmd;
#line 480 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp13_);
#line 483 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = cmd;
#line 483 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_process_helper_exec_script_sync (_tmp14_, &_tmp15_, &_tmp16_, FALSE, FALSE, TRUE, FALSE);
#line 483 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 483 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp15_;
#line 483 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 483 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp16_;
#line 483 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp17_;
#line 484 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = status;
#line 484 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp18_ == 0) {
#line 485 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 485 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 485 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 485 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 485 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 485 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_parent);
#line 485 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3018 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp19_;
#line 488 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp19_ = stderr;
#line 488 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp19_, FALSE);
#line 3025 "TeeJee.FileSystem.c"
		}
#line 465 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 465 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 465 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 465 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 465 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_parent);
#line 3037 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 492 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = g_strdup_printf (": %s", src_dir);
#line 492 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 492 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = g_strconcat (_ ("Dir not found"), _tmp21_, NULL);
#line 492 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 492 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp23_, FALSE, FALSE);
#line 492 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 492 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 3057 "TeeJee.FileSystem.c"
	}
#line 495 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 495 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3063 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_untar (const gchar* tar_file,
                               const gchar* dst_dir)
{
	gboolean result = FALSE;
#line 498 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (tar_file != NULL, FALSE);
#line 498 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_dir != NULL, FALSE);
#line 499 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (tar_file)) {
#line 3078 "TeeJee.FileSystem.c"
		gchar* cmd = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gint _tmp10_;
		gint _tmp11_;
#line 501 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (!tee_jee_file_system_dir_exists (dst_dir)) {
#line 502 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_dir_create (dst_dir, FALSE);
#line 3099 "TeeJee.FileSystem.c"
		}
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_escape_single_quote (tar_file);
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (dst_dir);
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("tar xvf '%s' --overwrite --same-permissions -C '%s'\n", _tmp1_, _tmp3_);
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 505 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp5_;
#line 509 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = cmd;
#line 509 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp6_);
#line 512 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = cmd;
#line 512 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tee_jee_process_helper_exec_script_sync (_tmp7_, &_tmp8_, &_tmp9_, FALSE, FALSE, TRUE, FALSE);
#line 512 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 512 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp8_;
#line 512 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 512 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp9_;
#line 512 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp10_;
#line 513 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = status;
#line 513 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp11_ == 0) {
#line 514 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 514 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 514 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 514 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 514 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3151 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp12_;
#line 517 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = stderr;
#line 517 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp12_, FALSE);
#line 3158 "TeeJee.FileSystem.c"
		}
#line 499 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 499 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 499 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 3166 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 521 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", tar_file);
#line 521 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 521 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("File not found"), _tmp14_, NULL);
#line 521 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 521 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 521 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 521 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 3186 "TeeJee.FileSystem.c"
	}
#line 524 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 524 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3192 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_chown (const gchar* dir_path,
                           const gchar* user,
                           const gchar* group)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint status = 0;
	gint _tmp4_;
#line 527 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 527 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (user != NULL, FALSE);
#line 527 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 528 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 528 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 528 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chown %s:%s -R '%s'", user, group, _tmp1_);
#line 528 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 528 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 528 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 529 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 529 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	status = _tmp4_;
#line 530 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 530 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 530 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3237 "TeeJee.FileSystem.c"
}


glong
tee_jee_file_system_dir_count (const gchar* path)
{
	glong result = 0L;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
#line 536 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 540 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("");
#line 540 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 545 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (path);
#line 545 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 545 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("find '%s' | wc -l", _tmp2_);
#line 545 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 545 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 545 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 546 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 546 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = tee_jee_process_helper_exec_script_sync (_tmp4_, &_tmp5_, &_tmp6_, FALSE, FALSE, TRUE, FALSE);
#line 546 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 546 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 546 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 546 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 546 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	ret_val = _tmp7_;
#line 547 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = atol (std_out);
#line 547 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 547 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 547 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 547 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3299 "TeeJee.FileSystem.c"
}


glong
tee_jee_file_system_dir_size (const gchar* path)
{
	glong result = 0L;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	glong _tmp10_;
#line 551 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 555 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (path);
#line 555 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 555 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("du -s -b '%s'", _tmp1_);
#line 555 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 555 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 555 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 557 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 557 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 557 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 557 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 557 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = atol (_tmp9_);
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 558 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3368 "TeeJee.FileSystem.c"
}


glong
tee_jee_file_system_dir_size_kb (const gchar* path)
{
	glong result = 0L;
#line 562 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 566 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = (glong) (tee_jee_file_system_dir_size (path) / 1024.0);
#line 566 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3382 "TeeJee.FileSystem.c"
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1025 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1025 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1026 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1026 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1028 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1028 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 3407 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1029 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1029 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1029 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 3415 "TeeJee.FileSystem.c"
	} else {
#line 1031 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = -1;
#line 1031 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 3421 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_file_tar_encrypt (const gchar* src_file,
                                      const gchar* dst_file,
                                      const gchar* password)
{
	gboolean result = FALSE;
#line 572 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 572 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_file != NULL, FALSE);
#line 572 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3440 "TeeJee.FileSystem.c"
		gchar* src_dir = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		gchar* dst_dir = NULL;
		gchar* _tmp2_;
		gchar* dst_name = NULL;
		gchar* _tmp3_;
		gchar* tar_name = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* tar_file = NULL;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* cmd = NULL;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp38_;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_ = NULL;
		gint _tmp41_;
		gint _tmp42_;
#line 574 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (dst_file)) {
#line 575 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (dst_file);
#line 3498 "TeeJee.FileSystem.c"
		}
#line 578 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_file);
#line 578 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		src_dir = _tmp0_;
#line 579 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_file);
#line 579 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 581 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_file_parent (dst_file);
#line 581 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		dst_dir = _tmp2_;
#line 582 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = tee_jee_file_system_file_basename (dst_file);
#line 582 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		dst_name = _tmp3_;
#line 583 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = dst_name;
#line 583 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = dst_name;
#line 583 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = string_slice (_tmp4_, (glong) 0, (glong) string_index_of (_tmp5_, ".gpg", 0));
#line 583 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tar_name = _tmp6_;
#line 584 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = dst_dir;
#line 584 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = tar_name;
#line 584 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strdup_printf ("%s/%s", _tmp7_, _tmp8_);
#line 584 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tar_file = _tmp9_;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tar_file;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_escape_single_quote (_tmp10_);
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = src_dir;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = src_name;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_file_system_escape_single_quote (_tmp16_);
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf ("tar cvf '%s' --overwrite -C '%s' '%s'\n", _tmp12_, _tmp15_, _tmp18_);
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 586 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp20_;
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = cmd;
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = tee_jee_file_system_escape_single_quote (dst_file);
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = tar_file;
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp25_ = tee_jee_file_system_escape_single_quote (_tmp24_);
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp26_ = _tmp25_;
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp27_ = g_strdup_printf ("gpg --passphrase '%s' -o '%s' --symmetric '%s'\n", password, _tmp23_, _tmp26_);
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp28_ = _tmp27_;
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = g_strconcat (_tmp21_, _tmp28_, NULL);
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp29_;
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp28_);
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp26_);
#line 591 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp30_ = cmd;
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tar_file;
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp32_ = tee_jee_file_system_escape_single_quote (_tmp31_);
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp33_ = _tmp32_;
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp34_ = g_strdup_printf ("rm -f '%s'\n", _tmp33_);
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp35_ = _tmp34_;
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp36_ = g_strconcat (_tmp30_, _tmp35_, NULL);
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp36_;
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp35_);
#line 596 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp33_);
#line 598 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp37_ = cmd;
#line 598 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp37_);
#line 601 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp38_ = cmd;
#line 601 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp41_ = tee_jee_process_helper_exec_script_sync (_tmp38_, &_tmp39_, &_tmp40_, FALSE, FALSE, TRUE, FALSE);
#line 601 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 601 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp39_;
#line 601 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 601 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp40_;
#line 601 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp41_;
#line 602 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp42_ = status;
#line 602 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp42_ == 0) {
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (dst_name);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (dst_dir);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 603 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3656 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp43_;
#line 606 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp43_ = stderr;
#line 606 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp43_, FALSE);
#line 3663 "TeeJee.FileSystem.c"
		}
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_file);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_name);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (dst_name);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (dst_dir);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 573 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_dir);
#line 3683 "TeeJee.FileSystem.c"
	}
#line 610 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 610 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3689 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                             const gchar* password)
{
	gchar* result = NULL;
	gchar* _tmp23_;
#line 614 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, NULL);
#line 614 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 616 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3705 "TeeJee.FileSystem.c"
		gchar* cmd = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* std_out = NULL;
		gchar* std_err = NULL;
		gint status = 0;
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gint _tmp15_;
		gint _tmp16_;
#line 623 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup ("");
#line 623 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp0_;
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = cmd;
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (src_file);
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("gpg --quiet --no-verbose --passphrase '%s' -o- --decrypt '%s'", password, _tmp3_);
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_tmp1_, _tmp5_, NULL);
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp6_;
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 625 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 629 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = cmd;
#line 629 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_strconcat (_tmp7_, " | tar xf - --to-stdout 2>/dev/null\n", NULL);
#line 629 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 629 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp8_;
#line 630 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = cmd;
#line 630 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = g_strconcat (_tmp9_, "exit $?\n", NULL);
#line 630 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 630 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp10_;
#line 632 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = cmd;
#line 632 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp11_);
#line 635 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = cmd;
#line 635 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = tee_jee_process_helper_exec_script_sync (_tmp12_, &_tmp13_, &_tmp14_, FALSE, FALSE, TRUE, FALSE);
#line 635 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 635 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		std_out = _tmp13_;
#line 635 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 635 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		std_err = _tmp14_;
#line 635 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp15_;
#line 636 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = status;
#line 636 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp16_ == 0) {
#line 637 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = std_out;
#line 637 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_err);
#line 637 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 637 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3797 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp17_;
			gchar* _tmp18_;
#line 640 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp17_ = std_err;
#line 640 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 641 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp18_ = g_strdup ("");
#line 641 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp18_;
#line 641 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_err);
#line 641 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_out);
#line 641 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 641 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3817 "TeeJee.FileSystem.c"
		}
#line 616 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 616 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 616 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 3825 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 645 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf (": %s", src_file);
#line 645 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 645 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = g_strconcat (_ ("File is missing"), _tmp20_, NULL);
#line 645 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = _tmp21_;
#line 645 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 645 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp22_);
#line 645 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp20_);
#line 3845 "TeeJee.FileSystem.c"
	}
#line 648 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp23_ = g_strdup ("");
#line 648 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp23_;
#line 648 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3853 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_decrypt_and_untar (const gchar* src_file,
                                       const gchar* dst_file,
                                       const gchar* password)
{
	gboolean result = FALSE;
#line 652 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 652 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_file != NULL, FALSE);
#line 652 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3871 "TeeJee.FileSystem.c"
		gchar* src_dir = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		gchar* tar_name = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* tar_file = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* cmd = NULL;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp46_;
		gchar* _tmp47_ = NULL;
		gchar* _tmp48_ = NULL;
		gint _tmp49_;
		gint _tmp50_;
#line 654 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (dst_file)) {
#line 655 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (dst_file);
#line 3935 "TeeJee.FileSystem.c"
		}
#line 658 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_file);
#line 658 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		src_dir = _tmp0_;
#line 659 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_file);
#line 659 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 660 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = src_name;
#line 660 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = src_name;
#line 660 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = string_slice (_tmp2_, (glong) 0, (glong) string_index_of (_tmp3_, ".gpg", 0));
#line 660 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tar_name = _tmp4_;
#line 661 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = src_dir;
#line 661 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = tar_name;
#line 661 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf ("%s/%s", _tmp5_, _tmp6_);
#line 661 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tar_file = _tmp7_;
#line 663 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_strdup ("");
#line 663 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp8_;
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = cmd;
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tar_file;
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_escape_single_quote (_tmp10_);
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf ("rm -f '%s'\n", _tmp12_);
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_tmp9_, _tmp14_, NULL);
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp15_;
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 666 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = cmd;
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tar_file;
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = tee_jee_file_system_escape_single_quote (_tmp17_);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = _tmp18_;
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = tee_jee_file_system_escape_single_quote (src_file);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = g_strdup_printf ("gpg --passphrase '%s' -o '%s' --decrypt '%s'\n", password, _tmp19_, _tmp21_);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = g_strconcat (_tmp16_, _tmp23_, NULL);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp24_;
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 668 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp19_);
#line 673 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp25_ = cmd;
#line 673 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp26_ = g_strconcat (_tmp25_, "status=$?; if [ $status -ne 0 ]; then exit $status; fi\n", NULL);
#line 673 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 673 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp26_;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp27_ = cmd;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp28_ = tar_file;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = tee_jee_file_system_escape_single_quote (_tmp28_);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp30_ = _tmp29_;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tee_jee_file_system_file_parent (dst_file);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp32_ = _tmp31_;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp33_ = tee_jee_file_system_escape_single_quote (_tmp32_);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp34_ = _tmp33_;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp35_ = g_strdup_printf ("tar xvf '%s' --overwrite --same-permissions -C '%s'\n", _tmp30_, _tmp34_);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp36_ = _tmp35_;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp37_ = g_strconcat (_tmp27_, _tmp36_, NULL);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp37_;
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp36_);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp34_);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp32_);
#line 675 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp30_);
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp38_ = cmd;
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp39_ = tar_file;
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp40_ = tee_jee_file_system_escape_single_quote (_tmp39_);
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp41_ = _tmp40_;
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp42_ = g_strdup_printf ("rm -f '%s'\n", _tmp41_);
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp43_ = _tmp42_;
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp44_ = g_strconcat (_tmp38_, _tmp43_, NULL);
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp44_;
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp43_);
#line 679 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp41_);
#line 681 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp45_ = cmd;
#line 681 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp45_);
#line 684 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp46_ = cmd;
#line 684 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp49_ = tee_jee_process_helper_exec_script_sync (_tmp46_, &_tmp47_, &_tmp48_, FALSE, FALSE, TRUE, FALSE);
#line 684 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 684 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp47_;
#line 684 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 684 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp48_;
#line 684 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp49_;
#line 685 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp50_ = status;
#line 685 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp50_ == 0) {
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 686 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 4119 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp51_;
#line 689 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp51_ = stderr;
#line 689 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp51_, FALSE, FALSE);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = FALSE;
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 690 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 4144 "TeeJee.FileSystem.c"
		}
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_file);
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_name);
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 653 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_dir);
#line 4160 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 694 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp52_ = g_strdup_printf (": %s", src_file);
#line 694 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp53_ = _tmp52_;
#line 694 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp54_ = g_strconcat (_ ("File is missing"), _tmp53_, NULL);
#line 694 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp55_ = _tmp54_;
#line 694 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp55_, FALSE, FALSE);
#line 694 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp55_);
#line 694 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp53_);
#line 4180 "TeeJee.FileSystem.c"
	}
#line 697 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 697 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4186 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_hash_md5 (const gchar* path)
{
	gchar* result = NULL;
	GChecksum* checksum = NULL;
	GChecksum* _tmp0_;
	FILE* stream = NULL;
	FILE* _tmp1_;
	guint8 fbuf[100] = {0};
	gsize size = 0UL;
	const gchar* digest = NULL;
	GChecksum* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 702 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 703 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_checksum_new (G_CHECKSUM_MD5);
#line 703 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	checksum = _tmp0_;
#line 704 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = g_fopen (path, "rb");
#line 704 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	stream = _tmp1_;
#line 708 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	while (TRUE) {
#line 4216 "TeeJee.FileSystem.c"
		FILE* _tmp2_;
		gsize _tmp3_;
		GChecksum* _tmp4_;
		gsize _tmp5_;
#line 708 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = stream;
#line 708 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		size = fread (fbuf, (gsize) 1, 100, _tmp2_);
#line 708 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = size;
#line 708 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (!(_tmp3_ > ((gsize) 0))) {
#line 708 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			break;
#line 4231 "TeeJee.FileSystem.c"
		}
#line 709 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = checksum;
#line 709 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = size;
#line 709 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_checksum_update (_tmp4_, fbuf, _tmp5_);
#line 4239 "TeeJee.FileSystem.c"
	}
#line 712 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp6_ = checksum;
#line 712 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = g_checksum_get_string (_tmp6_);
#line 712 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	digest = _tmp7_;
#line 714 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = g_strdup (digest);
#line 714 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp8_;
#line 714 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_fclose0 (stream);
#line 714 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_checksum_free0 (checksum);
#line 714 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4257 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_format_file_size (guint64 size,
                                      gboolean binary_units,
                                      const gchar* unit,
                                      gboolean show_units,
                                      gint decimals)
{
	gchar* result = NULL;
	gint _tmp0_ = 0;
	guint64 unit_k = 0ULL;
	guint64 _tmp1_ = 0ULL;
	guint64 unit_m = 0ULL;
	guint64 _tmp4_ = 0ULL;
	guint64 unit_g = 0ULL;
	guint64 _tmp7_ = 0ULL;
	guint64 unit_t = 0ULL;
	gchar* txt = NULL;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	guint64 _tmp12_;
#line 719 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (unit != NULL, NULL);
#line 723 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 723 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1024;
#line 4287 "TeeJee.FileSystem.c"
	} else {
#line 723 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1000;
#line 4291 "TeeJee.FileSystem.c"
	}
#line 723 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	unit_k = (guint64) _tmp0_;
#line 724 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 4297 "TeeJee.FileSystem.c"
		guint64 _tmp2_;
#line 724 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = unit_k;
#line 724 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1024 * _tmp2_;
#line 4303 "TeeJee.FileSystem.c"
	} else {
		guint64 _tmp3_;
#line 724 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = unit_k;
#line 724 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1000 * _tmp3_;
#line 4310 "TeeJee.FileSystem.c"
	}
#line 724 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	unit_m = _tmp1_;
#line 725 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 4316 "TeeJee.FileSystem.c"
		guint64 _tmp5_;
#line 725 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = unit_m;
#line 725 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = 1024 * _tmp5_;
#line 4322 "TeeJee.FileSystem.c"
	} else {
		guint64 _tmp6_;
#line 725 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = unit_m;
#line 725 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = 1000 * _tmp6_;
#line 4329 "TeeJee.FileSystem.c"
	}
#line 725 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	unit_g = _tmp4_;
#line 726 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 4335 "TeeJee.FileSystem.c"
		guint64 _tmp8_;
#line 726 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = unit_g;
#line 726 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = 1024 * _tmp8_;
#line 4341 "TeeJee.FileSystem.c"
	} else {
		guint64 _tmp9_;
#line 726 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = unit_g;
#line 726 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = 1000 * _tmp9_;
#line 4348 "TeeJee.FileSystem.c"
	}
#line 726 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	unit_t = _tmp7_;
#line 730 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = g_strdup ("");
#line 730 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	txt = _tmp10_;
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp12_ = unit_t;
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (size > _tmp12_) {
#line 4360 "TeeJee.FileSystem.c"
		gboolean _tmp13_ = FALSE;
		gint _tmp14_;
		gint _tmp15_;
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = strlen (unit);
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp15_ == 0) {
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = TRUE;
#line 4372 "TeeJee.FileSystem.c"
		} else {
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_strcmp0 (unit, "t") == 0;
#line 4376 "TeeJee.FileSystem.c"
		}
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = _tmp13_;
#line 4380 "TeeJee.FileSystem.c"
	} else {
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = FALSE;
#line 4384 "TeeJee.FileSystem.c"
	}
#line 732 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (_tmp11_) {
#line 4388 "TeeJee.FileSystem.c"
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		guint64 _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = txt;
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = g_strdup_printf ("%%'0.%df", decimals);
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = unit_t;
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = g_strdup_printf (_tmp18_, size / (1.0 * _tmp19_));
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = g_strconcat (_tmp16_, _tmp21_, NULL);
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		txt = _tmp22_;
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 733 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 734 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (show_units) {
#line 4420 "TeeJee.FileSystem.c"
			const gchar* _tmp23_ = NULL;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (binary_units) {
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp23_ = "Ti";
#line 4430 "TeeJee.FileSystem.c"
			} else {
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp23_ = "T";
#line 4434 "TeeJee.FileSystem.c"
			}
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp24_ = txt;
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp25_ = g_strdup_printf (" %sB", _tmp23_);
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp26_ = _tmp25_;
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp27_ = g_strconcat (_tmp24_, _tmp26_, NULL);
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			txt = _tmp27_;
#line 735 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp26_);
#line 4450 "TeeJee.FileSystem.c"
		}
	} else {
		gboolean _tmp28_ = FALSE;
		guint64 _tmp29_;
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = unit_g;
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (size > _tmp29_) {
#line 4459 "TeeJee.FileSystem.c"
			gboolean _tmp30_ = FALSE;
			gint _tmp31_;
			gint _tmp32_;
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp31_ = strlen (unit);
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp32_ = _tmp31_;
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp32_ == 0) {
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp30_ = TRUE;
#line 4471 "TeeJee.FileSystem.c"
			} else {
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp30_ = g_strcmp0 (unit, "g") == 0;
#line 4475 "TeeJee.FileSystem.c"
			}
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp28_ = _tmp30_;
#line 4479 "TeeJee.FileSystem.c"
		} else {
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp28_ = FALSE;
#line 4483 "TeeJee.FileSystem.c"
		}
#line 738 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp28_) {
#line 4487 "TeeJee.FileSystem.c"
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			guint64 _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp33_ = txt;
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp34_ = g_strdup_printf ("%%'0.%df", decimals);
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp35_ = _tmp34_;
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp36_ = unit_g;
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp37_ = g_strdup_printf (_tmp35_, size / (1.0 * _tmp36_));
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp38_ = _tmp37_;
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp39_ = g_strconcat (_tmp33_, _tmp38_, NULL);
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			txt = _tmp39_;
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp38_);
#line 739 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp35_);
#line 740 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (show_units) {
#line 4519 "TeeJee.FileSystem.c"
				const gchar* _tmp40_ = NULL;
				const gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (binary_units) {
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp40_ = "Gi";
#line 4529 "TeeJee.FileSystem.c"
				} else {
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp40_ = "G";
#line 4533 "TeeJee.FileSystem.c"
				}
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp41_ = txt;
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp42_ = g_strdup_printf (" %sB", _tmp40_);
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp43_ = _tmp42_;
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp44_ = g_strconcat (_tmp41_, _tmp43_, NULL);
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				txt = _tmp44_;
#line 741 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp43_);
#line 4549 "TeeJee.FileSystem.c"
			}
		} else {
			gboolean _tmp45_ = FALSE;
			guint64 _tmp46_;
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_tmp46_ = unit_m;
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (size > _tmp46_) {
#line 4558 "TeeJee.FileSystem.c"
				gboolean _tmp47_ = FALSE;
				gint _tmp48_;
				gint _tmp49_;
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp48_ = strlen (unit);
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp49_ = _tmp48_;
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (_tmp49_ == 0) {
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp47_ = TRUE;
#line 4570 "TeeJee.FileSystem.c"
				} else {
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp47_ = g_strcmp0 (unit, "m") == 0;
#line 4574 "TeeJee.FileSystem.c"
				}
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp45_ = _tmp47_;
#line 4578 "TeeJee.FileSystem.c"
			} else {
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp45_ = FALSE;
#line 4582 "TeeJee.FileSystem.c"
			}
#line 744 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp45_) {
#line 4586 "TeeJee.FileSystem.c"
				const gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				guint64 _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp50_ = txt;
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp51_ = g_strdup_printf ("%%'0.%df", decimals);
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp52_ = _tmp51_;
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp53_ = unit_m;
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp54_ = g_strdup_printf (_tmp52_, size / (1.0 * _tmp53_));
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp55_ = _tmp54_;
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp56_ = g_strconcat (_tmp50_, _tmp55_, NULL);
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				txt = _tmp56_;
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp55_);
#line 745 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp52_);
#line 746 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (show_units) {
#line 4618 "TeeJee.FileSystem.c"
					const gchar* _tmp57_ = NULL;
					const gchar* _tmp58_;
					gchar* _tmp59_;
					gchar* _tmp60_;
					gchar* _tmp61_;
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					if (binary_units) {
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp57_ = "Mi";
#line 4628 "TeeJee.FileSystem.c"
					} else {
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp57_ = "M";
#line 4632 "TeeJee.FileSystem.c"
					}
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp58_ = txt;
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp59_ = g_strdup_printf (" %sB", _tmp57_);
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp60_ = _tmp59_;
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp61_ = g_strconcat (_tmp58_, _tmp60_, NULL);
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					txt = _tmp61_;
#line 747 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp60_);
#line 4648 "TeeJee.FileSystem.c"
				}
			} else {
				gboolean _tmp62_ = FALSE;
				guint64 _tmp63_;
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				_tmp63_ = unit_k;
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (size > _tmp63_) {
#line 4657 "TeeJee.FileSystem.c"
					gboolean _tmp64_ = FALSE;
					gint _tmp65_;
					gint _tmp66_;
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp65_ = strlen (unit);
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp66_ = _tmp65_;
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					if (_tmp66_ == 0) {
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp64_ = TRUE;
#line 4669 "TeeJee.FileSystem.c"
					} else {
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp64_ = g_strcmp0 (unit, "k") == 0;
#line 4673 "TeeJee.FileSystem.c"
					}
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp62_ = _tmp64_;
#line 4677 "TeeJee.FileSystem.c"
				} else {
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp62_ = FALSE;
#line 4681 "TeeJee.FileSystem.c"
				}
#line 750 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
				if (_tmp62_) {
#line 4685 "TeeJee.FileSystem.c"
					const gchar* _tmp67_;
					gchar* _tmp68_;
					gchar* _tmp69_;
					guint64 _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp67_ = txt;
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp68_ = g_strdup_printf ("%%'0.%df", decimals);
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp69_ = _tmp68_;
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp70_ = unit_k;
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp71_ = g_strdup_printf (_tmp69_, size / (1.0 * _tmp70_));
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp72_ = _tmp71_;
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp73_ = g_strconcat (_tmp67_, _tmp72_, NULL);
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					txt = _tmp73_;
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp72_);
#line 751 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp69_);
#line 752 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 4717 "TeeJee.FileSystem.c"
						const gchar* _tmp74_ = NULL;
						const gchar* _tmp75_;
						gchar* _tmp76_;
						gchar* _tmp77_;
						gchar* _tmp78_;
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						if (binary_units) {
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
							_tmp74_ = "Ki";
#line 4727 "TeeJee.FileSystem.c"
						} else {
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
							_tmp74_ = "K";
#line 4731 "TeeJee.FileSystem.c"
						}
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp75_ = txt;
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp76_ = g_strdup_printf (" %sB", _tmp74_);
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp77_ = _tmp76_;
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp78_ = g_strconcat (_tmp75_, _tmp77_, NULL);
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						txt = _tmp78_;
#line 753 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_g_free0 (_tmp77_);
#line 4747 "TeeJee.FileSystem.c"
					}
				} else {
					const gchar* _tmp79_;
					gchar* _tmp80_;
					gchar* _tmp81_;
					gchar* _tmp82_;
#line 757 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp79_ = txt;
#line 757 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp80_ = g_strdup_printf ("%'0lld", size);
#line 757 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp81_ = _tmp80_;
#line 757 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_tmp82_ = g_strconcat (_tmp79_, _tmp81_, NULL);
#line 757 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 757 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					txt = _tmp82_;
#line 757 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp81_);
#line 758 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 4770 "TeeJee.FileSystem.c"
						const gchar* _tmp83_;
						gchar* _tmp84_;
#line 759 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp83_ = txt;
#line 759 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_tmp84_ = g_strconcat (_tmp83_, " B", NULL);
#line 759 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 759 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
						txt = _tmp84_;
#line 4781 "TeeJee.FileSystem.c"
					}
				}
			}
		}
	}
#line 765 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = txt;
#line 765 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4791 "TeeJee.FileSystem.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4814 "TeeJee.FileSystem.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 4818 "TeeJee.FileSystem.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 4824 "TeeJee.FileSystem.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 4828 "TeeJee.FileSystem.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 4832 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 4840 "TeeJee.FileSystem.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 4868 "TeeJee.FileSystem.c"
				goto __catch75_g_regex_error;
			}
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 4877 "TeeJee.FileSystem.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 4891 "TeeJee.FileSystem.c"
				goto __catch75_g_regex_error;
			}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 4902 "TeeJee.FileSystem.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 4916 "TeeJee.FileSystem.c"
	}
	goto __finally75;
	__catch75_g_regex_error:
	{
		GError* e = NULL;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1429 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 4930 "TeeJee.FileSystem.c"
	}
	__finally75:
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 4941 "TeeJee.FileSystem.c"
	}
}


gchar*
tee_jee_file_system_escape_single_quote (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 768 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 769 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = string_replace (file_path, "'", "'\\''");
#line 769 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 769 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4959 "TeeJee.FileSystem.c"
}


gint
tee_jee_file_system_chmod (const gchar* file,
                           const gchar* permission)
{
	gint result = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
#line 774 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 774 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (permission != NULL, 0);
#line 777 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file);
#line 777 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 777 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chmod %s '%s'", permission, _tmp1_);
#line 777 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 777 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 777 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 778 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 778 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp4_;
#line 778 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 778 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4998 "TeeJee.FileSystem.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 5023 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_resolve_relative_path (const gchar* filePath)
{
	gchar* result = NULL;
	gchar* filePath2 = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 782 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (filePath != NULL, NULL);
#line 786 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup (filePath);
#line 786 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	filePath2 = _tmp0_;
#line 787 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = filePath2;
#line 787 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (_tmp1_, "~")) {
#line 5045 "TeeJee.FileSystem.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_get_home_dir ();
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = filePath2;
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = filePath2;
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = strlen (_tmp6_);
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = string_slice (_tmp5_, (glong) 2, (glong) _tmp8_);
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strconcat (_tmp4_, _tmp10_, NULL);
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (filePath2);
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		filePath2 = _tmp11_;
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 788 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 5084 "TeeJee.FileSystem.c"
	}
	{
		gchar* output = NULL;
		gchar* _tmp12_;
		gchar* cmd = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
#line 792 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = g_strdup ("");
#line 792 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		output = _tmp12_;
#line 793 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = filePath2;
#line 793 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 793 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 793 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = g_strdup_printf ("realpath '%s'", _tmp15_);
#line 793 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = _tmp16_;
#line 793 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 793 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp17_;
#line 794 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = cmd;
#line 794 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_spawn_command_line_sync (_tmp18_, &_tmp19_, NULL, NULL, &_inner_error_);
#line 794 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 794 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		output = _tmp19_;
#line 794 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 794 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 794 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (output);
#line 5132 "TeeJee.FileSystem.c"
			goto __catch76_g_error;
		}
#line 795 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = output;
#line 795 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = string_strip (_tmp20_);
#line 795 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 795 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		output = _tmp21_;
#line 796 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = output;
#line 796 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_test (_tmp22_, G_FILE_TEST_EXISTS)) {
#line 797 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			result = output;
#line 797 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 797 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (filePath2);
#line 797 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 5155 "TeeJee.FileSystem.c"
		}
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 5161 "TeeJee.FileSystem.c"
	}
	goto __finally76;
	__catch76_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 801 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = e;
#line 801 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = _tmp23_->message;
#line 801 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp24_, FALSE, FALSE);
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 5181 "TeeJee.FileSystem.c"
	}
	__finally76:
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (filePath2);
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 791 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 5194 "TeeJee.FileSystem.c"
	}
#line 804 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = filePath2;
#line 804 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 5200 "TeeJee.FileSystem.c"
}


gint
tee_jee_file_system_rsync (const gchar* sourceDirectory,
                           const gchar* destDirectory,
                           gboolean updateExisting,
                           gboolean deleteExtra)
{
	gint result = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gint _tmp22_;
#line 807 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (sourceDirectory != NULL, 0);
#line 807 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (destDirectory != NULL, 0);
#line 811 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("rsync -avh");
#line 811 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 812 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (updateExisting) {
#line 812 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = "";
#line 5247 "TeeJee.FileSystem.c"
	} else {
#line 812 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = " --ignore-existing";
#line 5251 "TeeJee.FileSystem.c"
	}
#line 812 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = cmd;
#line 812 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strconcat (_tmp2_, _tmp1_, NULL);
#line 812 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 812 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 813 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	if (deleteExtra) {
#line 813 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = " --delete";
#line 5265 "TeeJee.FileSystem.c"
	} else {
#line 813 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = "";
#line 5269 "TeeJee.FileSystem.c"
	}
#line 813 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 813 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp6_ = g_strconcat (_tmp5_, _tmp4_, NULL);
#line 813 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 813 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp6_;
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = cmd;
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_file_system_escape_single_quote (sourceDirectory);
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_;
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = g_strconcat (_tmp9_, "//", NULL);
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp11_ = _tmp10_;
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp12_ = g_strdup_printf (" '%s'", _tmp11_);
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp13_ = _tmp12_;
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp14_;
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp13_);
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp11_);
#line 814 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp9_);
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp15_ = cmd;
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp16_ = tee_jee_file_system_escape_single_quote (destDirectory);
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp17_ = _tmp16_;
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp18_ = g_strdup_printf (" '%s'", _tmp17_);
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp19_ = _tmp18_;
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp20_ = g_strconcat (_tmp15_, _tmp19_, NULL);
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp20_;
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp19_);
#line 815 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp17_);
#line 816 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp21_ = cmd;
#line 816 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_tmp22_ = tee_jee_process_helper_exec_sync (_tmp21_, NULL, NULL);
#line 816 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp22_;
#line 816 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 816 "/builddir/build/BUILD/timeshift-18.2/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 5335 "TeeJee.FileSystem.c"
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



